#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct list
{
	char* name;
	struct list* next;
} lista;

void printlist(lista* l)
{
	if (l != NULL)
	{
		printf("%s\n", l->name);
		return printlist(l->next);
	}
}

void enqueue(lista** l, char* who)
{
	lista* temp;
	lista* new = malloc(sizeof(lista));
	new->name = who;
	new->next = NULL;
	if (*l == NULL)	
	{
		*l = new;
	}
	else if ((*l)->next != NULL)
	{
		temp = *l;		
		while(temp->next != NULL)
		{
			temp = temp->next;
		}
		temp->next = new;
	}
	else
	{
		(*l)->next = new;	
	}	
}

void dequeue(lista** l)
{
	lista* temp = *l;	
	if (*l != NULL)
	{
		*l = (*l)->next;
		free(temp);
	}
}

void list2array(lista* l, char** a, int dim)
{	
	int j;
	for(j = 0; j < dim; j++)
	{
		a[j] = l->name;
		l = l->next;
	}
}
////////////////////////////////////////////////////////////////////////////////////////////
void swap(char** a, int x, int y)
{
	char* temp;
	temp = a[x];
	a[x] = a[y];
	a[y] = temp;
}
////////////////////////////////////////////////////////////////////////////////////////////
int distrib(char** a, int sx, int px, int dx)
{
	char* temp;	
	if (px != dx) swap(a, px, dx);
	char* x = a[dx];
	int i = sx-1;
	int j;
	for(j = sx; j < dx; j++)
	{
		if (strcmp(a[j], x) <= 0)
		{
			i++;
			swap(a, i, j);
		}
	}
	i++;
	swap(a, dx, i);
	return i;
}

int QS(char** a, int sx, int dx)
{
	int px, perno;
	if (sx != dx)
	{
		px = sx;
		perno = distrib(a, sx, px, dx);
		QS(a, sx, perno-1);
		QS(a, perno+1, dx);
	}
}
///////////////////////////////////////////////////////////////////////////////////////
int main()
{
	int i = -1;
	int cont = 0; 
	lista* Q = NULL; 
	while(i != 0)
	{
		scanf("%d", &i);
		if (i == 1)
		{
			char* input = (char*) malloc(101*sizeof(char));			
			scanf("%s", input);
			enqueue(&Q, input);
			cont++;
		}
		else if (i == 2)
		{
			dequeue(&Q);
			cont--;
		}
	}
	char** a = malloc(cont*sizeof(char*));
	if (Q != NULL) list2array(Q, a, cont);
	if (cont > 0) QS(a, 0, cont-1);
	for(i = 0; i < cont; i++)
		printf("%s\n", a[i]);
	printf("$\n");
	return 0;
}

